uses hexadeci,crc32,sinflate,crt,dos;

var rollback,useroffset:longint;
    renaming:boolean;


{ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ }
{  Read-Only Multifile Section                                               }
{ __________________________________________________________________________ }

type bfilebuf=array[$0000..$7fff] of byte;
type bfile=record f:file; n:string; b:^bfilebuf; e,bo,fs,fp:longint; end;

procedure bfopen(var bf:bfile; s:string);
var fmbak:longint;
begin with bf do begin
  fmbak:=filemode; filemode:=0;
  assign(f,s); {$I-} reset(f,1); {$I+} e:=ioresult;
  filemode:=fmbak;
  if e=0 then begin
    new(b); fs:=filesize(f); bo:=$ffff0000; fp:=$00000000;
  end;
end; end;

procedure bfclose(var bf:bfile);
begin dispose(bf.b); close(bf.f); end;

function bfvalid(var bf:bfile; p:longint):boolean;
begin bfvalid:=(p>=0) and (p<bf.fs); end;

function bfinmem(var bf:bfile; p,l:longint):boolean;
begin bfinmem:=(p>=bf.bo) and (p+l<=bf.bo+$8000); end;

function bfeof(var bf:bfile):boolean;
begin bfeof:=bf.fp=bf.fs; end;

procedure bffillbuffer(var bf:bfile; p:longint);
begin with bf do begin
  bo:=p-$4000; if bo<$0000 then bo:=$0000; if bo+$8000>fs then bo:=fs-$8000;
  { filesize <$8000 }
  if bo<0 then begin
    bo:=0;
    seek(f,bo);
    blockread(f,b^,fs);
  end else begin
    seek(f,bo);
    blockread(f,b^,$8000);
  end;
  fp:=p;
end; end;

function bfbyte(var bf:bfile):byte;
var res:byte;
    l:longint;
begin if bfvalid(bf,bf.fp) then begin
  if not bfinmem(bf,bf.fp,1) then bffillbuffer(bf,bf.fp);
  move(bf.b^[bf.fp-bf.bo],res,1);
  bfbyte:=res;
  inc(bf.fp);
end else bf.e:=1; end;

function bfword(var bf:bfile):word;
var res:word;
begin if bfvalid(bf,bf.fp) then begin
  if not bfinmem(bf,bf.fp,2) then bffillbuffer(bf,bf.fp);
  move(bf.b^[bf.fp-bf.bo],res,2);
  bfword:=res;
  inc(bf.fp);
end else bf.e:=1; end;

function bflongint(var bf:bfile):longint;
var res:longint;
begin if bfvalid(bf,bf.fp) then begin
  if not bfinmem(bf,bf.fp,4) then bffillbuffer(bf,bf.fp);
  move(bf.b^[bf.fp-bf.bo],res,4);
  bflongint:=res;
  inc(bf.fp);
end else bf.e:=1; end;

function bfbytep(var bf:bfile; p:longint):byte;
var res:byte;
    l:longint;
begin if bfvalid(bf,p) then begin
  if not bfinmem(bf,p,1) then bffillbuffer(bf,p);
  move(bf.b^[p-bf.bo],res,1);
  bfbytep:=res;
  inc(bf.fp);
end else bf.e:=1; end;

function bfwordp(var bf:bfile; p:longint):word;
var res:word;
begin if bfvalid(bf,p) then begin
  if not bfinmem(bf,p,2) then bffillbuffer(bf,p);
  move(bf.b^[p-bf.bo],res,2);
  bfwordp:=res;
  inc(bf.fp);
end else bf.e:=1; end;

function bflongintp(var bf:bfile; p:longint):longint;
var res:longint;
begin if bfvalid(bf,p) then begin
  if not bfinmem(bf,p,4) then bffillbuffer(bf,p);
  move(bf.b^[p-bf.bo],res,4);
  bflongintp:=res;
  inc(bf.fp);
end else bf.e:=1; end;

procedure bfseek(var bf:bfile; p:longint);
begin bf.fp:=p; end;

type mfile=^amfile;
     amfile=record
              f:file;
              fs,fp,fe,fl:longint;
              next:mfile;
            end;
     mfilebuffer=^amfilebuffer;
     amfilebuffer=record
                    b:array [$0000..$7fff] of byte;
                    bp:word;
                    bs:longint;
                    be:longint;
                  end;

function mopen(var mf:mfile; name:string):boolean;
begin
  new(mf); assign(mf^.f,name); {$I-} reset(mf^.f,1); {$I+}
  if ioresult<>0 then begin
    dispose(mf);
    mopen:=FALSE;
  end else begin
    mf^.fs:=0;
    mf^.fp:=0;
    mf^.fe:=filesize(mf^.f)-1;
    mf^.fl:=mf^.fe+1;
    mopen:=TRUE;
    mf^.next:=NIL;
  end;
end;

function mappend(mf:mfile; name:string):boolean;
var oldmf:mfile;
begin
  oldmf:=mf; while mf^.next<>NIL do mf:=mf^.next;
  if mopen(mf^.next,name) then begin
    mf^.next^.fs:=oldmf^.fl;
    inc(mf^.next^.fe,oldmf^.fl);
    oldmf^.fl:=mf^.next^.fe+1;
    mappend:=TRUE;
  end else begin
    mf^.next:=NIL;
    mappend:=FALSE;
  end;
end;

procedure mseek(var mf:mfile; pos:longint);
begin
  mf^.fp:=pos;
end;

procedure mclose(var mf:mfile);
begin
  if mf^.next<>NIL then mclose(mf^.next);
  close(mf^.f);
  dispose(mf);
  mf:=NIL;
end;

function mblockread(mf:mfile; var x; amount:word):boolean;
type abuf=array[$0000..$fffe] of byte;
var oldmf:mfile;
    buf:^abuf;
    bufpos:longint;
begin
  oldmf:=mf;
  while (oldmf^.fp>mf^.fe) and (mf^.next<>NIL) do mf:=mf^.next;
  if oldmf^.fp<=mf^.fe then begin
    seek(mf^.f,oldmf^.fp-mf^.fs);
    if mf^.fe+1-oldmf^.fp>=amount then begin
      blockread(mf^.f,x,amount);
      inc(oldmf^.fp,amount);
    end else begin
      new(buf);
      bufpos:=0;
      repeat
        if mf^.fe+1<oldmf^.fp+amount-bufpos then begin
          blockread(mf^.f,buf^[bufpos],mf^.fe+1-oldmf^.fp);
          inc(bufpos,mf^.fe+1-oldmf^.fp);
          oldmf^.fp:=mf^.fe+1;
          mf:=mf^.next;
        end else begin
          blockread(mf^.f,buf^[bufpos],amount-bufpos);
          inc(oldmf^.fp,amount-bufpos);
          bufpos:=amount;
        end;
      until bufpos=amount;
      move(buf^,x,amount);
      dispose(buf);
    end;
  end else mblockread:=FALSE;
end;

function mfilesize(mf:mfile):longint;
begin
  mfilesize:=mf^.fl;
end;

function mfilepos(mf:mfile):longint;
begin
  mfilepos:=mf^.fp;
end;

{ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ }
{  Inflate Read/Write section                                                }
{ __________________________________________________________________________ }

type abuffer=array[$0000..$3fff] of byte;

var inflatev:record
               infile:mfile;
               outfile:file;
               inbuffer:^abuffer;
               inbufferpos:word;
               inbuffersize:word;
               insize:longint;
               outsize:longint;
               result:word;
               crc:longint;
             end;

var scrnv:record
            offsa,offsr,nofiles,filestart,fileend,crc:longint;
            extract,renamed,multiv,inst,percent:longint;
          end;
    hwunv:record
            infile:mfile;
            dumpfile:file;
            pkzip,realfound:boolean;
          end;

const hwunversion:word=$050a;
      hwundate:string[$0a]='2002-01-14';

procedure writestatus(s:string);
begin
  while length(s)<$47 do s:=s+' ';
  gotoxy(5,$11); write(s);
end;

procedure writehwuninfo;
var b:byte;
    xp,yp:byte;
begin
  xp:=wherex;
  yp:=wherey;
  textcolor(8);
  textbackground(0);
  gotoxy(1,4);
  for b:=$00 to $4e do write(' '); writeln;
  write(' '); textcolor(15); write(' Progress Overview '); textcolor(8);
  for b:=wherex to $4d do write(''); write(''); writeln;
  for b:=$05 to $0b do begin write(' '); gotoxy($4e,wherey); write(''); writeln; end;
  write(' '); for b:=wherex to $4d do write(''); write(''); writeln;
  for b:=$00 to $4e do write(' '); writeln;
  write(' '); textcolor(15); write(' Status '); textcolor(8);
  for b:=wherex to $4d do write(''); write(''); writeln;
  for b:=$0d to $0f do begin write(' '); gotoxy($4e,wherey); write(''); writeln; end;
  write(' '); for b:=wherex to $4d do write(''); write(''); writeln;
  textcolor(7);
  gotoxy(05,07); write('Approximated offset .... $',hexa(scrnv.offsa,8));
  gotoxy(05,08); write('Real archive offset .... $',hexa(scrnv.offsr,8));
  gotoxy(05,09); write('Last file start ........ $',hexa(scrnv.filestart,8));
  gotoxy(05,10); write('Last file end .......... $',hexa(scrnv.fileend,8));
  gotoxy(05,11); write('Last file CRC32 ........ $',hexa(scrnv.crc,8));
  gotoxy(42,07); write('Files extracted ........  ',scrnv.extract:8);
  gotoxy(42,08); write('Resolved filenames .....  ',scrnv.renamed:8);
  gotoxy(42,09); write('Multifiles .............  ',scrnv.multiv:8);
  gotoxy(42,10); write('Dialog & bitmap files ..  ',scrnv.inst:8);
  gotoxy(42,11); write('Full job completed .....   ',
                        scrnv.percent div 100:3,'.',scrnv.percent div 10 mod 10,scrnv.percent mod 10,'%');
end;

procedure writehwuntitle;
var b:byte;
begin
  textcolor(7);
  textbackground(0);
  clrscr;
  textcolor(1);
  for b:=$00 to $4e do write(''); writeln;
  textcolor(15);
  textbackground(1);
  write('  Heuristic Wise UNpacker v'); b:=hwunversion shr $0c;
  write(hexa(b,1),'.');
  write(hexa(hwunversion,3),' (',hwundate,')      (c) by Jgermeister Markus  ');
  writeln;
  textcolor(1);
  textbackground(0);
  for b:=$00 to $4e do write(''); writeln;
  textcolor(7);
end;

var scheisse:byte;

function inflateread:byte; far;
begin with inflatev do begin
  if inbufferpos>=inbuffersize then begin
    if mfilepos(infile)=mfilesize(infile) then begin
      SI_BREAK:=TRUE;
    end else begin
      scrnv.percent:=trunc(mfilepos(infile)/mfilesize(infile)*9000);
      inc(scheisse);
      if scheisse mod $03=$00 then writehwuninfo;
      if inbuffersize>mfilesize(infile)-mfilepos(infile) then inbuffersize:=mfilesize(infile)-mfilepos(infile);
      mblockread(infile,inbuffer^,inbuffersize);
      inbufferpos:=$0000;
    end;
  end;
  inflateread:=inbuffer^[inbufferpos];
  inc(insize);
  inc(inbufferpos);
end; end;

procedure inflatewrite(w:word); far;
begin with inflatev do begin
  inc(outsize,w);
  blockwrite(outfile,SI_WINDOW^,w);
  crcaddbuffer(crc,SI_WINDOW^,w);
end; end;

procedure inflate(inf:mfile; outf:string);
begin with inflatev do begin
  new(inbuffer);
  infile:=inf;
  assign(outfile,outf);
  rewrite(outfile,1);
  insize:=0;
  outsize:=0;
  inbuffersize:=sizeof(inbuffer^);
  inbufferpos:=inbuffersize;
  SI_READ:=inflateread;
  SI_WRITE:=inflatewrite;
  crcstart(crc);
  SI_INFLATE;
  mseek(inf,mfilepos(inf)-inbuffersize+inbufferpos);
  crcend(crc);
  result:=SI_ERROR;
  close(outfile);
  dispose(inbuffer);
end; end;

{ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ }
{  HWUN main section                                                         }
{ __________________________________________________________________________ }

var olddir:string;

function openwisefile:boolean;
var bo:boolean;
    fileno:byte;
    fn:string;
begin
  fn:=paramstr(1);
  bo:=mopen(hwunv.infile,olddir+'\'+fn);
  if bo then begin if fn[length(fn)-3]='.' then fn:=copy(fn,1,length(fn)-4);
  end else bo:=mopen(hwunv.infile,olddir+'\'+fn+'.exe');
  if bo then begin
    writestatus('Installation is made of 01 file');
    fileno:=2;
    while mappend(hwunv.infile,olddir+'\'+fn+'.w'+chr(fileno div 10+48)+chr(fileno mod 10+48)) do begin
      writestatus('Installation is made of '+chr(fileno div 10+48)+chr(fileno mod 10+48)+' files');
      inc(fileno);
    end;
  end else writestatus('ERROR: File could not be opened');
  openwisefile:=bo;
end;

procedure closewisefile;
begin
  mclose(hwunv.infile);
end;

procedure approximate;
type tbuf=array[$0000..$c1ff] of byte;
var buf:^tbuf;
    l0,l1,l2,l3:longint;
begin
  new(buf);
  writestatus('Approximating to archive offset');
  mseek(hwunv.infile,$0000);
  mblockread(hwunv.infile,buf^,$c000);
  scrnv.offsa:=$bffc;
  l2:=0;
  while ((buf^[scrnv.offsa]<>$00) or (buf^[scrnv.offsa+1]<>$00)) and (scrnv.offsa>$20) and (l2<>1) do begin
    dec(scrnv.offsa);
    if (buf^[scrnv.offsa]=$00) and (buf^[scrnv.offsa+1]=$00) then begin
      l1:=0;
      for l0:=$01 to $20 do if buf^[scrnv.offsa-l0]=$00 then inc(l1);
      if l1<$04 then dec(scrnv.offsa,2);
    end;
  end;
  inc(scrnv.offsa,2);
  while (buf^[scrnv.offsa+3]=$00) and (scrnv.offsa+4<$c000) do inc(scrnv.offsa,4);
  if (buf^[scrnv.offsa]<=$20) and (buf^[scrnv.offsa+1]>$00) and (buf^[scrnv.offsa+1]+scrnv.offsa+3<$c000) then begin
    l1:=buf^[scrnv.offsa+1]+$02;
    l2:=$00;
    for l0:=$02 to l1-$01 do if buf^[scrnv.offsa+l0]>=$80 then inc(l2);
    if l2*$100 div l1<$10 then inc(scrnv.offsa,l1);
  end;
  l0:=$02;
  while (l2<>$04034b50) and (l0<$80) and (scrnv.offsa-l0>=0) and (scrnv.offsa-l0<=$bffc) do begin
    move(buf^[scrnv.offsa-l0],l2,4);
    inc(l0);
  end;
  if l0<$80 then begin
    hwunv.pkzip:=TRUE;
    l0:=$0000;
    l1:=$0000;
    while (l1<>$04034b50) and (l0<scrnv.offsa) do begin
      move(buf^[l0],l1,4);
      inc(l0);
    end;
    dec(l0);
    scrnv.offsa:=l0;
    if l1<>$04034b50 then hwunv.pkzip:=FALSE;
  end else hwunv.pkzip:=FALSE;
  writehwuninfo;
end;

procedure findreal;
var newcrc,pos:longint;
begin
  if not hwunv.pkzip then begin
    if scrnv.offsa<$100 then scrnv.offsa:=$100 else
    if scrnv.offsa>$bf00 then scrnv.offsa:=$bf00;
  end;
  if (scrnv.offsa>=$0000) and (scrnv.offsa<=$ffff) then begin
    writestatus('Detecting real archive offset');
    pos:=$0000;
    repeat
      mseek(hwunv.infile,scrnv.offsa+pos);
      inflate(hwunv.infile,'WISE0001');
      mblockread(hwunv.infile,newcrc,4);
      scrnv.offsr:=scrnv.offsa+pos;
      inc(pos);
      if pos mod $9=$00 then writehwuninfo;
    until ((inflatev.crc=newcrc) and (inflatev.result=$0000) and (newcrc<>$00000000)) or (pos=$100);
    if ((inflatev.crc<>newcrc) or (newcrc=$00000000) or (inflatev.result<>$0000)) and (pos=$100) then begin
      pos:=-1;
      repeat
        mseek(hwunv.infile,scrnv.offsa+pos);
        inflate(hwunv.infile,'WISE0001');
        mblockread(hwunv.infile,newcrc,4);
        scrnv.offsr:=scrnv.offsa+pos;
        dec(pos);
        if pos mod $9=$00 then writehwuninfo;
      until ((inflatev.crc=newcrc) and (inflatev.result=$0000) and (newcrc<>$00000000)) or (pos=-$100);
    end;
  end else begin
    inflatev.crc:=not newcrc;
    pos:=-$100;
  end;
  if ((inflatev.crc<>newcrc) or (newcrc=$00000000) or (inflatev.result<>$0000)) and (pos=-$100) then begin
    writestatus('ERROR: The file doesn''t seem to be a WISE installation');
    hwunv.realfound:=FALSE;
    scrnv.offsr:=$ffffffff;
  end else hwunv.realfound:=TRUE;
  writehwuninfo;
end;

procedure extractfiles;
var newcrc:longint;
    attempt,fs:longint;
    buf:array[$00..$3ff] of byte;
    len1,len2:word;
begin
  writestatus('Extracting files');
  assign(hwunv.dumpfile,'WISE0000');
  rewrite(hwunv.dumpfile,1);
  mseek(hwunv.infile,scrnv.offsr);
  repeat
    inc(scrnv.extract);
    fs:=mfilepos(hwunv.infile);
    if hwunv.pkzip then begin
      mblockread(hwunv.infile,buf,$e);
      mblockread(hwunv.infile,newcrc,$04);
      mblockread(hwunv.infile,buf,$08);
      mblockread(hwunv.infile,len1,$02);
      mblockread(hwunv.infile,len2,$02);
      if len1+len2>0 then mblockread(hwunv.infile,buf,len1+len2);
    end;
    inflate(hwunv.infile,'WISE'+hexa(scrnv.extract,4));
    scrnv.filestart:=fs;
    scrnv.crc:=inflatev.crc;
    if hwunv.pkzip then inflatev.crc:=$04034b50;
    scrnv.fileend:=scrnv.filestart+inflatev.insize-1;
    if inflatev.result=$0000 then begin
      mblockread(hwunv.infile,newcrc,4);
      attempt:=0;
      while (inflatev.crc<>newcrc) and (attempt<8) and (mfilepos(hwunv.infile)+1<mfilesize(hwunv.infile)) do begin
        mseek(hwunv.infile,mfilepos(hwunv.infile)-3);
        mblockread(hwunv.infile,newcrc,4);
        inc(attempt);
      end;
      scrnv.fileend:=mfilepos(hwunv.infile)-1;
      if hwunv.pkzip then begin
        dec(scrnv.fileend,4);
        mseek(hwunv.infile,mfilepos(hwunv.infile)-4);
      end;
    end;
    if (inflatev.result<>$0000) or (newcrc<>inflatev.crc) then begin
      inflatev.crc:=$ffffffff;
      newcrc:=$fffffffe;
    end;
    writehwuninfo;
    blockwrite(hwunv.dumpfile,scrnv.filestart,4);
  until (newcrc<>inflatev.crc);
  blockwrite(hwunv.dumpfile,scrnv.fileend,4);
  close(hwunv.dumpfile);
end;

procedure renamefiles;
var bf:bfile;
    df:bfile;
    fn,nn:string;
    fileno:longint;
    sh0,sh1,sh2,offs,l,l0,l1,l2,l3,l4,l5,res:longint;
    instcnt:longint;
    f:file;
begin
  writestatus('Searching for script file');
  fileno:=0;
  res:=1;
  instcnt:=0;
  while (fileno<scrnv.extract) and (fileno<6) and (res<>0) do begin
    inc(fileno);
    bfopen(bf,'WISE'+hexa(fileno,4));
    l:=$0000;
    while (res<>0) and (l<bf.fs) do begin
      while (l<bf.fs) and ((bfbytep(bf,l+0)<>$25) or (bfbytep(bf,l+1)<>$5c)) do inc(l);
      if l<bf.fs then begin
        l1:=$01;
        while (l1<$40) and ((bfbytep(bf,l-l1+0)<>$25) or (bfbytep(bf,l-l1+1)=$5c)) do inc(l1);
        if l1<$40 then res:=0 else inc(l);
      end;
    end;
    if res<>0 then bfclose(bf);
  end;
  if (fileno<6) and (fileno<scrnv.extract) then begin
    writestatus('Calculating offset shift value');
    bfopen(df,'WISE0000');
    l5:=(df.fs-$04) div $04;

    repeat

    repeat
      l1:=bflongintp(df,l5*$04-$04);
      l2:=bflongintp(df,l5*$04-$00);
      l:=bf.fs-$07;
      res:=1;
      while (l>=0) and (res<>0) do begin
        dec(l,1);
        l3:=bflongintp(bf,l+$00);
        l4:=bflongintp(bf,l+$04);
        if (l4>l3) and (l4<l2) and (l3<l1) and (l4-l3=l2-l1) then res:=0;
      end;
      if res<>0 then dec(l5);
    until (res=0) or (l5=0);
    sh0:=l1-l3;

    if (res=0) then repeat
      l1:=bflongintp(df,l5*$04-$04);
      l2:=bflongintp(df,l5*$04-$00);
      l:=bf.fs-$07;
      res:=1;
      while (l>=0) and (res<>0) do begin
        dec(l,1);
        l3:=bflongintp(bf,l+$00);
        l4:=bflongintp(bf,l+$04);
        if (l4>l3) and (l4<l2) and (l3<l1) and (l4-l3=l2-l1) then res:=0;
      end;
      if res<>0 then dec(l5);
    until (res=0) or (l5=0);
    sh1:=l1-l3;

    until (l5=0) or ((res=0) and (sh0=sh1));

    if (res=0) then begin
      { shiftvalue = sh0 }
      writestatus('Renaming files');
      l5:=-$04;
      while (l5+8<df.fs) do begin
        inc(l5,$04);
        l1:=bflongintp(df,l5+$00);
        l2:=bflongintp(df,l5+$04);
        l0:=$ffffffff;
        res:=1;
        while (l0+$29<bf.fs) and (res<>0) do begin
          inc(l0,$01);
          l3:=bflongintp(bf,l0+$00);
          l4:=bflongintp(bf,l0+$04);
          if (l1=l3+sh0) and (l2=l4+sh0) then res:=0;
        end;
      if res=0 then begin
          l2:=bfwordp(bf,l0-2);
          nn:='';
          offs:=l0;
          inc(l0,$28);
          res:=2;
          if bfbytep(bf,l0)=$25 then begin
            while bfbytep(bf,l0)<>$00 do begin
              nn:=nn+char(bfbytep(bf,l0));
              if (bfbytep(bf,l0)<$20) then res:=1;
              if (bfbytep(bf,l0)=$25) and (res<>1) then res:=3;
              if (bfbytep(bf,l0)=$5c) and (bfbytep(bf,l0-1)=$25) and (res=3) then res:=4;
              if res=4 then res:=0;
              inc(l0);
            end;
          end;
          if res<>0 then res:=$80;
        end;
        l1:=(l5+$04) div $04;
        if res=0 then begin
          l0:=1;
          while (l0<length(nn)) do begin
            if nn[l0]='%' then nn:=copy(nn,1,l0-1)+copy(nn,l0+1,length(nn)-l0) else
            if (nn[l0]='\') and (nn[l0-1]='\') then nn:=copy(nn,1,l0-1)+copy(nn,l0+1,length(nn)-l0) else
            inc(l0);
          end;
          assign(f,'WISE'+hexa(l1,4));
         { Make directories }
          l0:=0;
          while l0<length(nn) do begin
            inc(l0);
            if nn[l0]='\' then begin
              {$I-} MkDir(copy(nn,1,l0-1)); l:=IoResult; {$I+}
            end;
          end;
         { Rename file }
          inc(scrnv.renamed);
          repeat
            {$I-} rename(f,nn); {$I+}
            l0:=IoResult;
            if l0=0 then begin
              filemode:=$11;
              assign(f,nn);
              reset(f,1);
             {$I+} setftime(f,longint(bfwordp(bf,offs+$08))*$10000+longint(bfwordp(bf,offs+$0a))); {$I-}
              l0:=IoResult;
              close(f);
            end else inc(scrnv.multiv);
            l2:=length(nn);
            while (nn[l2]<>'.') and (l2>$00) do dec(l2);
            if l2=$00 then nn:=nn+'.!' else begin
              nn:=copy(nn,1,l2)+'!.'+copy(nn,l2+1,length(nn)-l2);
            end;
          until (l0=0) or (length(nn)>$fb);
        end else if res=$80 then begin
          inc(instcnt);
         { Rename file }
          assign(f,'WISE'+hexa(l1,4));
          {$I-} rename(f,'INST'+hexa(instcnt,4)); l0:=IoResult; {$I+}
          inc(scrnv.inst);
        end;
        scrnv.percent:=trunc(l5/scrnv.extract/4*1000)+9000;
        writehwuninfo;
      end;
    end;
    bfclose(df);
    bfclose(bf);
    writestatus('Job done'); scrnv.percent:=10000; writehwuninfo;
  end else begin
    writestatus('Scriptfile not found');
  end;
end;

var b:byte;
    options:string;
    l:integer;
begin
  writehwuntitle;
  if paramcount<2 then begin
    writeln(' Usage: HWUN <file (without .exe)> <directory> [options (case-insensitive)]');
    writeln;
    writeln(' Options: Bxxxx - rollback xxxx (hex) bytes from approximated offset');
    writeln('          R     - disable renaming/moving of WISExxxx files');
    writeln('          Uxxxx - take xxxx instead of approximated offset');
    writeln;
    writeln(' Example: HWUN install.exe B0020r -> 32 bytes rollback without renaming');
    writeln('          HWUN someprg.exe u377A  -> start at offset $0000377a');
    writeln;
    writeln(' News:    - completely new design');
    writeln('          - E_WISE alike with destination directory');
    writeln('          - multifile support (exe, w01, w02, ...)');
    writeln('          - true PKZIP format detection and support');
    writeln('          - approximation routine improved again');
    writeln('          - new selfmade inflate routines (slower)');
    writeln('          - real archive offset finder now stable (own inflate)');
    writeln('          - renaming routine now very secure');
    writeln;
    writeln(' Contact: jaegermeister.markus@gmx.de, http://jmeister.cjb.net');
  end else begin
    {$I-} mkdir(paramstr(2)); {$I+} l:=ioresult;
    getdir(0,olddir);
    if olddir[length(olddir)]='\' then olddir:=copy(olddir,1,length(olddir)-1);
    {$I-} chdir(paramstr(2)); {$I+} l:=ioresult;
    if l<>0 then begin
      writehwuninfo;
      writestatus('ERROR: Passed directory could not be created');
      halt(1);
    end;
    rollback:=0;
    useroffset:=-1;
    renaming:=true;
    if paramcount=3 then begin
      options:=paramstr(3);
      b:=1;
      while b<=length(options) do begin
        if upcase(options[b])='B' then begin
          rollback:=deci(copy(options,b+1,4));
          inc(b,4);
        end else if upcase(options[b])='U' then begin
          useroffset:=deci(copy(options,b+1,4));
          inc(b,4);
        end else if upcase(options[b])='R' then begin
          renaming:=FALSE;
        end;
        inc(b);
      end;
    end;
    writehwuninfo;
    if openwisefile then begin
      approximate;
      if not hwunv.pkzip then begin
        if useroffset>=0 then scrnv.offsa:=useroffset else dec(scrnv.offsa,rollback);
        findreal;
        if hwunv.realfound then begin
          extractfiles;
          if renaming then renamefiles;
        end;
      end else begin
        scrnv.offsr:=scrnv.offsa;
        extractfiles;
        if renaming then renamefiles;
      end;
      closewisefile;
    end;
    chdir(olddir);
    writehwuninfo;
    writeln;
    writeln;
    writeln;
    writeln;
    writeln;
    writeln;
    writeln;
    writeln;
    writeln;
  end;
end.
